/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	snmpInitAgent.h
 *
 * Date:	May 1994
 *
 * Purpose:	Initialize partymib configuration files.
 *
 * Author:	Peter Peters
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */

#ifndef	SNMPINITAGENT_H
#define	SNMPINITAGENT_H

/* 
 *	Type and macro definitions.
 */
#define MAXRECSTR 100 
#define ARLEN 100 
#define MAXSTRLEN 40
#define BUFSIZE 512
#define MAXAPPL 100
#define FILELEN 100
#define FILENAMELEN 100
#define HOSTNAMELEN 100
#define INTARRLEN 32
#define lengthEntry 100

typedef int	INTEGER;	/* local integer representation, int: 32 bits */
extern int errno;

/*
 *	The SNMPV2 party database group related structures
 */
typedef struct {
        char 		FriendbyName[MAXRECSTR];
        char  		partyIdentity[MAXRECSTR]; 	
	INTEGER		partyIndex;		/* position in the partyTable */
	char		partyTDomain[MAXRECSTR];
        char            IPaddress[MAXRECSTR];
	char		partyTAddress[MAXRECSTR];
	char		partyMaxMessageSize[MAXRECSTR];
	char		partyLocal; 			/* own or remote party */
	char		partyAuthProtocol[MAXRECSTR];
	char		partyAuthClock[MAXRECSTR];
	char		partyAuthPrivate[MAXRECSTR];
	char		partyAuthPublic[MAXRECSTR];
	char 	 	partyAuthLifeTime[MAXRECSTR];
	char		partyPrivProtocol[MAXRECSTR];
	char		partyPrivPrivate[MAXRECSTR];
	char		partyPrivPublic[MAXRECSTR];
} PartyEntry;

typedef struct {
        char 		contextName[MAXRECSTR];
        char		contextIdentity[MAXRECSTR];
        char            IPaddress[MAXRECSTR];
	INTEGER		contextIndex;	/* position in the contextTable */
	char 		contextLocal;	/* objects on this or remote system */
	INTEGER		contextViewIndex; /* could be a union structure */
	char		contextLocalEntity[MAXRECSTR];
	char		contextLocalTime[MAXRECSTR];
	char		contextProxyDstParty[MAXRECSTR];
	char		contextProxySrcParty[MAXRECSTR];
	char		contextProxyContext[MAXRECSTR];
} ContextEntry;

typedef struct {
	char		aclTarget[MAXRECSTR];
	char		aclSubject[MAXRECSTR];
	char		aclResources[MAXRECSTR];
	char		aclPrivileges[MAXRECSTR];
} AclEntry;

typedef struct {
	int		viewIndex;
	char   		viewSubtree[MAXRECSTR];
	char 		viewMask[MAXRECSTR];
	char		viewType[MAXRECSTR];
} ViewEntry;

extern char PartyIdentityStand[];
extern char ContextIdentityStand[];
extern char Partyfile[];
extern char Viewfile[];
extern char Aclfile[];
extern char Contextfile[];
extern char ViewIniFile[];
extern char AclIniFile[];
extern char ContextIniFile[];
extern char PartyIniFile[];

#endif	/* SNMPINITAGENT_H */


