/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	xInitAgent.h
 *
 * Date:	May 1994
 *
 * Purpose:	Initialize partymib configuration files.
 *
 * Author:	Peter Peters
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */
#ifndef _xInitAgent_h_
#define _xInitAgent_h_

#include <ResourceExtendSet.h>
#include <ErrorWarningMessages.h>
#include <snmpInitAgent.h>
/* messages used by the initprocess */

#define xIAStatusLine0  "Initializing the records and parties.\0"
#define xIAStatusLine1  "Checking the IPaddresses and input ranges.\0"
#define xIAStatusLine2  "Copying IPaddresses and OID's.\0"
#define xIAStatusLine3  "Initializing and opening the files.\0"
#define xIAStatusLine4  "Open file for genrating the partyMIB instances.\0"
#define xIAStatusLine5  "Generating the files.\0"
#define xIAStatusLine6  "Closing the files.\0"
#define xIAStatusLine7  "Initialization is ready.\0"
#define xIAStatusLine8  "Creating party, view, acl and context entries.\0"
#define xIAStatusLine9  "Generating the view record\0"
#define xIAStatusLine10 "Generating the acl record\0"
#define xIAStatusLine11 "Default values are loaded into the input boxes.\0"
#define xIAStatusLine12 "Generating the context record.\0"

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriSetDefaultsInitAgent
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriSetDefaultsInitAgentCB( *hostmanager *hostagent *portmanager *portagent *maxmessize *statustext )
 * purpose : default-button action, loads defaults into widgets
 * remarks : if use as c-function(not resource code) put resource argument in the client_data as string
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriSetDefaultsInitAgent( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriStartInitAgent
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriStartInitAgentCB( ( *hostmanager *hostagent *portmanager *portagent *maxmessize *statustext )
 * purpose : Starts init process, under ok-button
 * remarks : if use as c-function(not resource code) put resource argument in the client_data as string
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriStartInitAgent( Widget , XtPointer , XtPointer );

#endif
