/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	xInitManager.c
 *
 * Date:	May 1994
 *
 * Purpose:	Initialize partymib configuration files.
 *
 * Author:	Peter Peters
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */
#ifndef _xInitManager_h_
#define _xInitManager_h_

#include <ResourceExtendSet.h>

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriStartInitManager
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriStartInitManagerCB( *hostmanager *hostagent *statustext )
 * purpose : starts the init-process under the ok-button
 * remarks : if use as c-function(not resource code) put resource argument in the client_data as string
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriStartInitManager( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriSetDefaultInitManager
 * Argument: current_widget(in)  , client_data(in) , call_data(in)
 * resource: xAriSetDefaultInitManagerCB( *hostmanager *hostagent )
 * purpose : action under the defaults-button, fetch defaults and put in boxes
 * remarks : if use as c-function(not resource code) put resource argument in the client_data as string
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriSetDefaultInitManager( Widget , XtPointer , XtPointer );

/* ---------------------------- */
/* Statuslines for xInitManager */
/* ---------------------------- */
#define xIMStatusLine0  "Checking the IP-addresses.\0"
#define xIMStatusLine1  "Start opening the files.\0"
#define xIMStatusLine2  "Creating the party, acl, view and context.\0"
#define xIMStatusLine3  "Initializing the party-entry.\0"
#define xIMStatusLine4  "Initializing the acl-entry.\0"
#define xIMStatusLine5  "Initializing the context- and view-entry.\0"
#define xIMStatusLine6  "Copying the agent-entries to the manager-entries.\0"
#define xIMStatusLine7  "Opening the manager-files for writing.\0"
#define xIMStatusLine8  "Writing the manager-files.\0"
#define xIMStatusLine9  "Closing the manager-files.\0"
#define xIMStatusLine10 "Initialization is ready.\0"
#define xIMStatusLine11 "Default values are loaded into the input boxes.\0"
#define xIMStatusLine12 "Appending Party-entry\0"
#define xIMStatusLine13 "Appending Context-entry\0"
#define xIMStatusLine14 "Appending View-entry\0"
#define xIMStatusLine15 "Appending Acl-entry\0"

#endif /* _xInitManager_h_ */
