/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	xSNMPAri.c
 *
 * Date:	May 1994
 *
 * Purpose:	Athena Resource Interpreter for the initialize window
 *              application
 *
 * Author:	Peter Peters
 *
 * Remarks:	The original interpreter of the WCL v2.5 with the extended
 *		callback functions
 *
 * -----------------------------------------------------------------------
 */
 
#include <X11/Wc/COPY>

#define MAIN

#include <Intrinsic.h>
#include <X11/Wc/WcCreate.h>
#include <X11/Xp/Xp.h>
#include <ResourceExtendSet.h>

/* definitions of extensions */

#include <xWsnmpTester.h>

/* other includes */

/******************************************************************************
**  Private Data
******************************************************************************/

/* All Wcl applications should provide at least these Wcl options:
*/
static XrmOptionDescRec options[] = {
    WCL_XRM_OPTIONS
};


/******************************************************************************
**  Private Functions
******************************************************************************/

/*ARGSUSED*/
static void RegisterApplication ( app )
    XtAppContext app;
{
    /* -- Useful shorthand for registering things with the Wcl library */
#define RCP( name, class  ) WcRegisterClassPtr   ( app, name, class );
#define RCO( name, constr ) WcRegisterConstructor( app, name, constr );
#define RAC( name, func   ) WcRegisterAction     ( app, name, func );
#define RCB( name, func   ) WcRegisterCallback   ( app, name, func, NULL );

    /* -- register widget classes and constructors */
    /* -- Register application specific actions */
    /* -- Register application specific callbacks */
	RCB( "xAriTesterFilenamesCB" , xAriTesterFilenames )
	RCB( "xAriTesterAutoCallCB" , xAriTesterAutoCall )
	RCB( " xAriTesterSnmpOpenCB" ,  xAriTesterSnmpOpen )
	RCB( "xAriTesterExitCB" , xAriTesterExit )
	RCB( "xAriTesterResetCB" , xAriTesterReset )
	RCB( "xAriTesterNextCB" , xAriTesterNext )
	RCB( "xAriTesterPreviousCB" , xAriTesterPrevious )
	RCB( "xAriTesterExecuteCB" , xAriTesterExecute )
}


/******************************************************************************
*   MAIN function
******************************************************************************/

#if defined(XtSpecificationRelease) && XtSpecificationRelease == 4
#define CARDINAL(argc) (Cardinal*)(&argc)
#else
#define CARDINAL(argc) (&argc)
#endif

char **argenv;

main ( argc, argv , arge )
    int   argc;
    char* argv[];
    char* arge[];
{   
    /*  -- Intialize Toolkit creating the application shell
    */
    Widget appShell = XtInitialize (
        WcAppName(  argc, argv ),    /* application shell name               */
        WcAppClass( argc, argv ),    /* class name is 1st resource file name */
        options, XtNumber(options),  /* resources which can be set from argv */
	CARDINAL(argc), argv
    );
    XtAppContext app = XtWidgetToApplicationContext(appShell);

    argenv = arge;

    /*  -- Register all application specific callbacks and widget classes
    */
    RegisterApplication ( app );

    /*  -- Register all Athena and Public widget classes, CBs, ACTs
    */
    XpRegisterAll ( app );

    /*  -- Create widget tree below toplevel shell using Xrm database
    */
    WcWidgetCreation ( appShell );

    /*  -- Realize the widget tree and enter the main application loop
    */
    XtRealizeWidget ( appShell );
    XtMainLoop ( );
}

#undef MAIN
