/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	xWsnmpTester.c
 *
 * Date:	June 1994
 *
 * Purpose:  	The extension of the Athena Widget Set including
 *              for the xsnmpTester, the window actions
 *
 * Author:	Peter Peters
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */

/* the include file */

#include <xWsnmpTester.h>
#include <xsnmpTester.h>
#include <apiSNMP.h>

extern char **argenv;

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Variable: logfile_pointer,scenario_head,scenario_current,test_outputtext
 * Argument: 
 * resource: none
 * purpose : global variable for the button actions
 * remarks : only used to fetch and update at the end of the function, do not use as step values
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

FILE    *log_fp = NULL;
command *scenario_head = NULL , *scenario_current = NULL ;
char    *test_outputstring="\0";


/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterFilenames
 * Argument: current_widget(in) ,  client_data(in) , call_data(in)
 * resource: xAriTesterFilenamesCB( *inputscenariofilename *inputlogfilename 
 *           *scenariofilename *logfilename *outputtext *nextcall *prevcall
 *           *autocall *resetcall *proccall *processcallname)
 * purpose : Loads the filenames out of widgets and opens them
 * remarks :
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterFilenames( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
  char 	input_scenario_widget_name[ maximum_string_length ] , input_log_widget_name[ maximum_string_length ] ,
	scenario_widget_name[ maximum_string_length ] , log_widget_name[ maximum_string_length ] ,
	output_widget_name[ maximum_string_length ] , nextcall_widget_name[ maximum_string_length ] ,
	prevcall_widget_name[ maximum_string_length ] , autocall_widget_name[ maximum_string_length ] ,
	resetcall_widget_name[ maximum_string_length ] , proccall_widget_name[ maximum_string_length ] , 
	procname_widget_name[ maximum_string_length ];
  char  scenariofilename[ maximum_string_length ] , logfilename[ maximum_string_length ] , string_text[ maximum_string_length ] , textbuf[27];
  FILE	*scenario_fp,*temp_fps,*temp_fpl;
  FILE  *clockval;
  Widget input_scenario_widget , input_log_widget , scenario_widget , log_widget , output_widget , nextcall_widget , prevcall_widget , autocall_widget , resetcall_widget , proccall_widget , procname_widget ;

  if( xRESInitVariables( current_widget ) != Ok_Status ) return;
  if( 	xRESGetnString( 0 , client_data , input_scenario_widget_name ) 	== Ok_Status &&
	xRESGetnString( 1 , client_data , input_log_widget_name ) 	== Ok_Status &&
	xRESGetnString( 2 , client_data , scenario_widget_name ) 	== Ok_Status &&
	xRESGetnString( 3 , client_data , log_widget_name ) 		== Ok_Status &&
	xRESGetnString( 4 , client_data , output_widget_name ) 		== Ok_Status &&
	xRESGetnString( 5 , client_data , nextcall_widget_name ) 	== Ok_Status &&
	xRESGetnString( 6 , client_data , prevcall_widget_name ) 	== Ok_Status &&
	xRESGetnString( 7 , client_data , autocall_widget_name ) 	== Ok_Status &&
	xRESGetnString( 8 , client_data , resetcall_widget_name ) 	== Ok_Status &&
	xRESGetnString( 9 , client_data , proccall_widget_name ) 	== Ok_Status &&
	xRESGetnString( 10 , client_data , procname_widget_name ) 	== Ok_Status )
  {
    if( ( input_scenario_widget = WcFullNameToWidget( current_widget , input_scenario_widget_name ) ) 	!= NULL &&
	( input_log_widget 	= WcFullNameToWidget( current_widget , input_log_widget_name ) ) 	!= NULL &&
	( scenario_widget	= WcFullNameToWidget( current_widget , scenario_widget_name ) ) 	!= NULL &&
	( log_widget		= WcFullNameToWidget( current_widget , log_widget_name ) )		!= NULL &&
	( output_widget		= WcFullNameToWidget( current_widget , output_widget_name ) )		!= NULL &&
	( nextcall_widget	= WcFullNameToWidget( current_widget , nextcall_widget_name ) )		!= NULL &&
	( prevcall_widget	= WcFullNameToWidget( current_widget , prevcall_widget_name ) )		!= NULL &&
	( autocall_widget	= WcFullNameToWidget( current_widget , autocall_widget_name ) )		!= NULL &&
	( proccall_widget	= WcFullNameToWidget( current_widget , proccall_widget_name ) )		!= NULL &&
	( procname_widget	= WcFullNameToWidget( current_widget , procname_widget_name ) )		!= NULL &&
	( resetcall_widget	= WcFullNameToWidget( current_widget , resetcall_widget_name ) )	!= NULL )
    {
/* fetch the filenames of the dialog widgets */
      strcpy( scenariofilename	, (String)XawDialogGetValueString( input_scenario_widget ) );
      strcpy( logfilename 	, (String)XawDialogGetValueString( input_log_widget ) );
      if( WcStrLen( scenariofilename ) == 0 || WcStrLen( logfilename ) == 0 ) return;
/* if both files can be opened, than go further to make it happen, otherwise no changes */
      if( ( temp_fps = fopen( scenariofilename , "r" ) ) == NULL )
      {
	if( xRESPlaceStringinText( &test_outputstring , pErrorMessage13 ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
        else
	  printf( "ERROR: tester.%s\n" , pErrorMessage13 );
	WcSetValueFromString( input_scenario_widget , "value" , "\0" );
	WcSetValueFromString( input_log_widget , "value" , "\0" );
        return;
      }
      if( (temp_fpl = fopen( logfilename , "a+" ) ) == NULL )
      {
	if( xRESPlaceStringinText( &test_outputstring , pErrorMessage14 ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
	else
	  printf( "ERROR: tester.%s\n" , pErrorMessage14 );
	WcSetValueFromString( input_scenario_widget , "value" , "\0" );
	WcSetValueFromString( input_log_widget , "value" , "\0" );
        fclose( temp_fps );
        return;	   
      }
      fclose( temp_fps );
      fclose( temp_fpl );
/* is there a log and an existing scenario file, free them */
	if( log_fp != NULL )
	{
	  fclose( log_fp );
	  log_fp = NULL;
	}
	if( scenario_head != NULL )
	{
          TesterFreeScenario( &scenario_head );
	  Asn1Free( scenario_head );
	  scenario_head = NULL;
	}
/* does the scenario file exist yes, and the logfile be created yes*/
      scenario_fp = fopen( scenariofilename , "r" );
      log_fp = fopen( logfilename , "a+" );
/* all files could be found, place filenames in their widgets */
      xRESPrintString( scenario_widget_name 	, scenariofilename );
      xRESPrintString( log_widget_name		, logfilename );
/* read scenario file and close it */
      if( readScenario( scenario_fp , &scenario_head ) != Ok_Status )
      {
	if( xRESPlaceStringinText( &test_outputstring , pErrorMessage17 ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
         scenario_head = scenario_current = NULL;
        return;
      }
      fclose( scenario_fp );
      scenario_current = scenario_head;
      if( scenario_current != NULL ) xRESPrintString( procname_widget_name , scenario_current->line );
/* place date & time into header of logfile ? */
	strcpy( string_text , xSTmessage5 );
	strcat( string_text , xSTmessage6 );
	strcat( string_text , scenariofilename );
	strcat( string_text , "\n\0" );
	strcat( string_text , xSTmessage7 );
	strcat( string_text , logfilename );
	strcat( string_text , "\n\0" );
	strcat( string_text , xSTmessage8 );
	clockval = popen( "date" , "r" );
	fgets( textbuf , 20 , clockval );
	pclose( clockval );
	strcat( string_text , textbuf );
	strcat( string_text , "\n" );
	strcat( string_text , xSTmessage9 );

	fprintf( log_fp , string_text );
	if( xRESPlaceStringinText( &test_outputstring , string_text ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
/* activate all the desired buttons */
      WcSetSensitiveCB( current_widget , nextcall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , prevcall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , proccall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , autocall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , resetcall_widget_name , NULL );
    }
/* else not all widgets reached */
    else
      printf( "ERROR: tester.%s\n" , pErrorMessage15 );
  }
/* not all true names found */
  else
    printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterSnmpOpen
 * Argument: current_widget(in) ,  client_data(in) , call_data(in)
 * resource: xAriTesterSnmpOpenCB( )
 * purpose : Opens to the SPM
 * remarks :
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterSnmpOpen( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
	if( snmpOpen( APPLICATIONNAMEtester , argenv ) != OK )
        {
		printf( "ERROR: tester.%s\n" , pErrorMessage18 );
		WcExitCB( current_widget , "\0" , "\0" );
		exit(-1);
        }
}
/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterAutoCall
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterAutoCallCB( *filesmenu *exitbutton *helpbutton *nextcall *prevcall *autocall *resetcalls *proccall *outputtext *processcallname )
 * purpose : Starts the auto scenario process
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterAutoCall( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
  command *scenario_element;
  char    filesmenu_widget_name[ maximum_string_length ] , exitbutton_widget_name[ maximum_string_length ] , 
	  helpbutton_widget_name[ maximum_string_length ] , nextcall_widget_name[ maximum_string_length ] ,
	  prevcall_widget_name[ maximum_string_length ] , autocall_widget_name[ maximum_string_length ] ,
	  output_widget_name[ maximum_string_length ] , resetcall_widget_name[ maximum_string_length ] , 
	  proccall_widget_name[ maximum_string_length ] , procname_widget_name[ maximum_string_length ];
  Widget  filesmenu_widget , exitbutton_widget , helpbutton_widget , nextcall_widget , prevcall_widget , 
	  autocall_widget , output_widget , resetcall_widget , proccall_widget , procname_widget;

  if( xRESInitVariables( current_widget ) != Ok_Status ) return;
  if( 	xRESGetnString( 0 , client_data , filesmenu_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 1 , client_data , exitbutton_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 2 , client_data , helpbutton_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 3 , client_data , nextcall_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 4 , client_data , prevcall_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 5 , client_data , autocall_widget_name ) 	== Ok_Status &&
  	xRESGetnString( 8 , client_data , output_widget_name ) 		== Ok_Status &&
 	xRESGetnString( 7 , client_data , proccall_widget_name )	== Ok_Status &&
	xRESGetnString( 9 , client_data , procname_widget_name ) 	== Ok_Status &&
	xRESGetnString( 6 , client_data , resetcall_widget_name ) 	== Ok_Status)
  {
    if( ( filesmenu_widget 	= WcFullNameToWidget( current_widget , filesmenu_widget_name ) ) 	!= NULL &&
	( exitbutton_widget	= WcFullNameToWidget( current_widget , exitbutton_widget_name ) ) 	!= NULL &&
	( helpbutton_widget	= WcFullNameToWidget( current_widget , helpbutton_widget_name ) ) 	!= NULL &&
	( nextcall_widget	= WcFullNameToWidget( current_widget , nextcall_widget_name ) ) 	!= NULL &&
	( prevcall_widget	= WcFullNameToWidget( current_widget , prevcall_widget_name ) ) 	!= NULL &&
	( autocall_widget	= WcFullNameToWidget( current_widget , autocall_widget_name ) ) 	!= NULL &&
	( output_widget		= WcFullNameToWidget( current_widget , output_widget_name ) )	 	!= NULL &&
	( proccall_widget	= WcFullNameToWidget( current_widget , proccall_widget_name ) )	 	!= NULL &&
	( procname_widget	= WcFullNameToWidget( current_widget , procname_widget_name ) )	 	!= NULL &&
	( resetcall_widget	= WcFullNameToWidget( current_widget , resetcall_widget_name ) )	!= NULL)
    {
/* set all buttons insensitive */
      WcSetInsensitiveCB( current_widget , filesmenu_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , exitbutton_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , helpbutton_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , nextcall_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , prevcall_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , autocall_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , proccall_widget_name , NULL );
      WcSetInsensitiveCB( current_widget , resetcall_widget_name , NULL );
/* clears the proc api call field */
       xRESPrintString( procname_widget_name , xSTmessage4 );
/* fetch the current command list pointer and process.... */
      if( processScenario( scenario_current , log_fp , output_widget_name , &test_outputstring ) != Ok_Status )
      {
/* print an error in log */
	if( xRESPlaceStringinText( &test_outputstring , pErrorMessage19 ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
      }
/* sets the current scenario pointer to the beginning */
	if( xRESPlaceStringinText( &test_outputstring , xSTmessage2 ) == Ok_Status )
          xRESPrintStringGo2End( output_widget_name , test_outputstring );
      scenario_current = scenario_head;
      if( scenario_current != NULL ) xRESPrintString( procname_widget_name , scenario_current->line );
/* Set all buttons to active */
      WcSetSensitiveCB( current_widget , filesmenu_widget_name , NULL );
      WcSetSensitiveCB( current_widget , exitbutton_widget_name , NULL );
      WcSetSensitiveCB( current_widget , helpbutton_widget_name , NULL );
      WcSetSensitiveCB( current_widget , nextcall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , prevcall_widget_name , NULL );
      WcSetSensitiveCB( current_widget , autocall_widget_name , NULL ); 
      WcSetSensitiveCB( current_widget , proccall_widget_name , NULL );    
      WcSetSensitiveCB( current_widget , resetcall_widget_name , NULL );
    }
    else
      printf( "ERROR: tester.%s\n" , pErrorMessage15 );
  }
  else
    printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterExit
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterExitCB( *outputtext )
 * purpose : Ends the xsnmpTester by closing the logfile and the SPM
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterExit( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
  char   output_widget_name[ maximum_string_length ] , tempfilename[ maximum_string_length ] , Wccommandprocess[ maximum_string_length ];
  FILE *dummy_fp;

  xRESInitVariables( current_widget );
  if( xRESGetnString( 0 , client_data , output_widget_name ) == Ok_Status )
  {
    if( WcFullNameToWidget( current_widget , output_widget_name ) != NULL )
    {
      fclose( log_fp );
      if( snmpClose( 0 ) )
      {
        if( xRESPlaceStringinText( &test_outputstring , pErrorMessage20 ) == Ok_Status )
          xRESPrintStringnPauseGo2End( output_widget_name , test_outputstring , 4 );
        else
          printf( "ERROR: tester.%s\n" , pErrorMessage19 );
      }
      CreateTempFileName( tempfilename );
      if( ( dummy_fp = fopen( tempfilename , "r" ) ) != NULL )
      {
	fclose( dummy_fp );
	strcpy( Wccommandprocess , "rm \0" );
      	strcat( Wccommandprocess , tempfilename );
      	WcSystemCB( current_widget , Wccommandprocess , NULL );
      }
    }
    else
      printf( "ERROR: tester.%s\n" , pErrorMessage15 );
  }
  else
    printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterReset
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterResetCB( *processcallname *outputtext )
 * purpose : Set the current scenario pointer to the beginning
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterReset( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
  char output_widget_name[ maximum_string_length ] , procname_widget_name[ maximum_string_length ] ;

  xRESInitVariables( current_widget );
  if( xRESGetnString( 1 , client_data , output_widget_name ) == Ok_Status &&
      xRESGetnString( 0 , client_data , procname_widget_name ) == Ok_Status )
  {
    if( WcFullNameToWidget( current_widget , output_widget_name ) 	!= NULL &&
	WcFullNameToWidget( current_widget , procname_widget_name ) 	!= NULL )
    {
      scenario_current = scenario_head;
      if( scenario_current != NULL ) xRESPrintString( procname_widget_name , scenario_current->line );
      fflush( log_fp );
      if( xRESPlaceStringinText( &test_outputstring , xSTmessage1 ) == Ok_Status )
        xRESPrintStringnPauseGo2End( output_widget_name , test_outputstring , 1 );
    }   
    else
      printf( "ERROR: tester.%s\n" , pErrorMessage15 );
  }
  else
    printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterNext
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterNextCB( *processcallname *outputtext )
 * purpose : Go to the next call in the scenariolist if available
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterNext( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
	char procname_widget_name[ maximum_string_length ] , output_widget_name[ maximum_string_length ];

	xRESInitVariables( current_widget );
	if( xRESGetnString( 0 , client_data , procname_widget_name ) == Ok_Status &&
	    xRESGetnString( 1 , client_data , output_widget_name ) == Ok_Status )
	{
		if( WcFullNameToWidget( current_widget , procname_widget_name ) != NULL &&
		    WcFullNameToWidget( current_widget , output_widget_name ) != NULL )
		{
			if( scenario_current->next != NULL ) scenario_current = scenario_current->next;
			if( scenario_current != NULL )
				xRESPrintString( procname_widget_name , scenario_current->line );
			else
			{
				if( xRESPlaceStringinText( &test_outputstring , xSTmessage3 ) == Ok_Status )
          			  xRESPrintStringGo2End( output_widget_name , test_outputstring );
			}
		}
		else
		  printf( "ERROR: tester.%s\n" , pErrorMessage15 );
	}
	else
  	  printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterPrevious
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterPreviousCB( *processcallname *outputtext )
 * purpose : Go to the previous call in the scenariolist if available
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterPrevious( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
	char procname_widget_name[ maximum_string_length ] , output_widget_name[ maximum_string_length ];

	xRESInitVariables( current_widget );
	if( xRESGetnString( 0 , client_data , procname_widget_name ) == Ok_Status &&
	    xRESGetnString( 1 , client_data , output_widget_name ) == Ok_Status )
	{
		if( WcFullNameToWidget( current_widget , procname_widget_name ) != NULL &&
		    WcFullNameToWidget( current_widget , output_widget_name ) != NULL )
		{
			if( scenario_current->prev != NULL ) scenario_current = scenario_current->prev;
			if( scenario_current != NULL ) xRESPrintString( procname_widget_name , scenario_current->line );
		}
		else
		  printf( "ERROR: tester.%s\n" , pErrorMessage15 );
	}
	else
  	  printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterExecute
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterExecuteCB(*processcallname *outputtext ) 
 * purpose : Executes the current scenario call 
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterExecute( Widget current_widget , XtPointer client_data , XtPointer call_data )
{
	char procname_widget_name[ maximum_string_length ] , output_widget_name[ maximum_string_length ];

	xRESInitVariables( current_widget );
	if( xRESGetnString( 0 , client_data , procname_widget_name ) == Ok_Status &&
	    xRESGetnString( 1 , client_data , output_widget_name ) == Ok_Status )
	{
		if( WcFullNameToWidget( current_widget , procname_widget_name ) != NULL &&
		    WcFullNameToWidget( current_widget , output_widget_name ) != NULL )
		{
			if( processCommand( scenario_current , log_fp , output_widget_name , &test_outputstring ) != Ok_Status )
      			{
/* print an error in log */
				if( xRESPlaceStringinText( &test_outputstring , pErrorMessage19 ) == Ok_Status )
          				xRESPrintStringGo2End( output_widget_name , test_outputstring );
      			}
			if( scenario_current != NULL ) xRESPrintString( procname_widget_name , scenario_current->line );
		}
		else
		  printf( "ERROR: tester.%s\n" , pErrorMessage15 );
	}
	else
  	  printf( "ERROR: tester.%s\n" , pErrorMessage16 );
}


/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: CreateTempFileName
 * Argument: filename(out)
 * resource: none
 * purpose : Create a tempfile name related to the hostname and the processnumber
 * remarks : Gives a status back
 *++++++++++++++++++++++++++++++++++++++++++++++
*/
int CreateTempFileName( char *tempfilename )
{
  int return_status = Ok_Status, pidnumber;
  char hostname[ maximum_string_length ];

  strcpy( tempfilename , APPLICATIONNAMEtester );
  strcat( tempfilename , "_\0" );
  gethostname( hostname , maximum_string_length );
  strcat( tempfilename , hostname );
  strcat( tempfilename , ".temp" );
  return( return_status ); 
}

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: TesterFreeScenario
 * Argument: scenario start (in/out)
 * resource: none
 * purpose : frees the scenario list
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/
void TesterFreeScenario( command **head )
{
	command *current_element , *next_element;

	current_element = *head;
	if( current_element != NULL )
	{
		current_element = current_element->next;
		while( current_element != NULL )
		{
			next_element = current_element->next;
			Asn1Free( current_element );
			current_element = next_element;
		}
	}
}

