/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	xWsnmpTester.h
 *
 * Date:	June 1994
 *
 * Purpose:  	The header of an extension of the Athena Widget Set including
 *              for the xsnmpTester
 *
 * Author:	Peter Peters
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */

/* the include files */
#ifndef _xWsnmpTester_h_
#define _xWsnmpTester_h_

/* include files */

#include <ResourceExtendSet.h>
#include <stdio.h>
#include <ErrorWarningMessages.h>
#include <X11/Wc/WcCreate.h>
#include <xsnmpTester.h>
#include <time.h>

/* external variables */
/* the environment variable */

/* status messages */

#define xSTmessage1 "*************************************************\nThe current pointer is placed at the beginning of the scenario-list.\n*************************************************\n\0"
#define xSTmessage2 "*************************************************\nEnd of Scenario File\n*************************************************\n\0"
#define xSTmessage3 "*************************************************\nEnd of scenario files is reached\n*************************************************\n\0"
#define xSTmessage4 "******* auto-processing the scenario *******\0"
#define xSTmessage5 "*************************************************\nUsing the following files:\n\0"
#define xSTmessage6 "Scenariofile: \0"
#define xSTmessage7 "Logfile     : \0"
#define xSTmessage8 "Date stamp  : \0"
#define xSTmessage9 "*************************************************\n"

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterFilenames
 * Argument: current_widget(in) ,  client_data(in) , call_data(in)
 * resource: xAriTesterFilenamesCB( *inputscenariofilename *inputlogfilename 
 *           *scenariofilename *logfilename *outputtext *nextcall *prevcall
 *           *autocall )
 * purpose : Loads the filenames out of widgets and opens them
 * remarks :
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterFilenames( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterSnmpOpen
 * Argument: current_widget(in) ,  client_data(in) , call_data(in)
 * resource: xAriTesterSnmpOpenCB( *outputtext )
 * purpose : Opens to the SPM
 * remarks :
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterSnmpOpen( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterAutoCall
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterAutoCallCB( *filesmenu *exitbutton *helpbutton *nextcall *prevcall *autocall *outputtext )
 * purpose : Starts the auto scenario process
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterAutoCall( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterExit
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterExitCB( *outputtext )
 * purpose : Ends the xsnmpTester by closing the logfile and the SPM
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterExit( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterReset
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterExitCB( *outputtext )
 * purpose : Set the current scenario pointer to the beginning
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/
void xAriTesterReset( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterNext
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterNextCB(
 * purpose : Go to the next call in the scenariolist if available
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterNext( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterPrevious
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterPreviousCB(
 * purpose : Go to the previous call in the scenariolist if available
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterPrevious( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: xAriTesterExecute
 * Argument: current_widget(in) , client_data(in) , call_data(in)
 * resource: xAriTesterExecuteCB( 
 * purpose : Executes the current scenario call 
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/

void xAriTesterExecute( Widget , XtPointer , XtPointer );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: CreateTempFileName
 * Argument: filename(out)
 * resource: none
 * purpose : Create a tempfile name related to the hostname and the processnumber
 * remarks : Gives a status back
 *++++++++++++++++++++++++++++++++++++++++++++++
*/
int CreateTempFileName( char * );

/*++++++++++++++++++++++++++++++++++++++++++++++
 * Function: TesterFreeScenario
 * Argument: scenario start (in/out)
 * resource: none
 * purpose : frees the scenario list
 * remarks : 
 *++++++++++++++++++++++++++++++++++++++++++++++
*/
void TesterFreeScenario( command ** );

#endif
